> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a bill run

GET https://rest.test.zuora.com/object-query/billing-runs/{key}

Retrieve the details of a specific Bill Run object.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/object-query/object-queries/query-billing-run-by-key

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required) — Object ID or Number.

### Query parameters

- `pageSize` (integer, optional, default: 10) — The maximum number of results to return in a single page. If the specified `pageSize` is less than 1 or greater than 99, Zuora will return a 400 error.
- `cursor` (string, optional) — A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with `next_page=W3sib3JkZXJ=`, your subsequent call can include `cursor=W3sib3JkZXJ=` in order to fetch the next page of the list.
- `sort[]` (list of string, optional) — A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. `accountnumber.ASC`) or descending (e.g. `accountnumber.DESC`). You cannot sort on properties in arrays. If the array-type properties are specified for the `sort[]` parameter, they are ignored.
- `expand[]` (list of string, optional) — Allows you to expand responses by including related object information in a single call. The Bill Run object does not support expanding any related objects.
- `filter[]` (list of string, optional) — A case-insensitive filter on the list.
- `fields[]` (list of string, optional) — A case-insensitive query parameter that allows you to specify which fields are returned in the response.
- `includeNullFields` (boolean, optional, default: false) — Specifies whether to include fields with the `null` value in the response. - If set to `true`, all fields will be returned in the response, including those with the `null` value. - If set to `false`, only fields with non-null values will be returned.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `id` (string, optional) — The unique identifier of the bill run.
- `createdById` (string, optional) — The unique identifier of the user who created the bill run.
- `createdDate` (datetime, optional) — The date and time when the bill run was created.
- `updatedById` (string, optional) — The unique identifier of the user who last updated the bill run.
- `updatedDate` (datetime, optional) — The date and time when the bill run was last updated.
- `billingRunNumber` (string, optional) — The number of the bill run.
- `billingRunType` (enum, optional, default: Regular) — The type of the bill run. - You can use this field only if the Catch-Up Bill Run feature is enabled. - You must specify this field to create a catch up bill run.
  - Allowed values: `Regular`, `CatchUp`
- `endDate` (datetime, optional) — The end date and time when the bill run completes.
- `errorMessage` (string, optional) — The error message generated by a failed billing run.
- `executedDate` (datetime, optional) — The date and time when the bill run was executed.
- `invoiceDate` (date, optional) — The date that appears on the invoice being created, in the `yyyy-mm-dd` format. The value cannot fall in a closed accounting period.
- `name` (string, optional) — The name of the bill run.
- `numberOfAccounts` (long, optional) — The number of accounts included in this bill run processing.
- `numberOfInvoices` (long, optional) — The number of invoices generated from this bill run.
- `numberOfCreditMemos` (long, optional) — The number of credit memos generated from this bill run.
- `postedDate` (datetime, optional) — The date when the bill run was posted.
- `startDate` (datetime, optional) — The start date and time of the bill run.
- `status` (enum, optional) — The status of the bill run.
  - Allowed values: `Pending`, `Processing`, `Completed`, `Error`, `Canceled`, `Posted`, `PostInProgress`, `CancelInProgress`, `RemoveInProgress`, `Paused`
- `targetDate` (date, optional) — The target date for this bill run, only valid for ad-hoc bill runs.
- `targetType` (enum, optional) — The target type for this bill run.
  - Allowed values: `SingleAccount`, `AllAccount`
- `totalTime` (long, optional) — The total time in milliseconds for the bill run to complete.
- `accountId` (string, optional) — The unique identifier of the account included in the bill run.
- `batches` (list of string, optional) — The batch of accounts for this bill run, this field can not exist with `billRunFilters` together. **Values:** `AllBatches` or an array of `Batch`*n* where *n* is a number between 1 and 50, for example, `Batch7`.
- `billCycleDay` (enum, optional) — The day of the bill cycle. This field is only valid when `batches` is specified. **Values:** - `AllBillCycleDays` or one of numbers 1 - 31 for an ad-hoc bill run - `AllBillCycleDays`, one of numbers 1 - 31, or `AsRunDay` for a scheduled bill run
  - Allowed values: `AllBillCycleDays`, `AsRunDay`
- `noEmailForZeroAmountInvoice` (boolean, optional) — Whether to suppress emails for invoices with zero total amount generated in this bill run after the bill run is complete.
- `autoEmail` (boolean, optional) — Whether to automatically send emails after Auto-Post is complete.
- `autoPost` (boolean, optional) — Whether to automatically post the bill run after the bill run is created.
- `autoRenewal` (boolean, optional) — Whether to automatically renew auto-renew subscriptions that are up for renewal.
- `invoicesEmailed` (boolean, optional) — Whether the invoices have been emailed after the bill run is complete.
- `lastEmailSentTime` (datetime, optional) — The date and time when the last email was sent.
- `targetDateOffSet` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill runs.
- `invoiceDateOffSet` (integer, optional) — The offset compared to bill run execution date, only valid for scheduled bill runs.
- `chargeTypeToExclude` (enum, optional) — The types of the charges to be excluded from the generation of billing documents.
  - Allowed values: `OneTime`, `Recurring`, `Usage`
- `scheduledExecutionTime` (datetime, optional) — The scheduled execution time for a bill run.
- `repeatType` (enum, optional) — The repeat type of the bill run.
  - Allowed values: `None`, `Daily`, `Weekly`, `Monthly`
- `repeatFrom` (date, optional) — The start date of the scheduled bill run.
- `repeatTo` (date, optional) — The end date of of the scheduled bill run.
- `runTime` (integer, optional) — The scheduled run time (hour) of day.
- `timeZone` (string, optional) — Timezone of the scheduled bill run.
- `monthlyOnDay` (string, optional) — The repeat day in a month.
- `weeklyOnDay` (enum, optional) — The repeat day in a week.
  - Allowed values: `Mon`, `Tue`, `Wed`, `Thu`, `Fri`, `Sat`, `Sun`
- `includeSubscriptions` (boolean, optional, default: true) — Indicates whether to bill subscriptions in the bill run.
- `includeOrderLineItems` (boolean, optional, default: true) — Indicates whether to bill order line items in the bill run.

## Errors

### 500 Internal Server Error

Internal server error

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

### 400 Client Request Error

Invalid input

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

## Types

### CommonOqErrorResponseReasonsItems

- `code` (integer, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "id": "8ad0887e805061c8018063a09fe2685a",
  "createdById": "2c92c0f97a98ca23017a990996124672",
  "createdDate": "2022-04-25T19:08:32-07:00",
  "updatedById": "2c92c0f972a852360172bbe22ac551b6",
  "updatedDate": "2025-02-06T23:10:15-08:00",
  "billingRunNumber": "BR-00000005",
  "billingRunType": "Regular",
  "endDate": "2022-04-25T19:08:37-07:00",
  "executedDate": "2022-04-25T19:08:34-07:00",
  "invoiceDate": "2022-04-25",
  "numberOfAccounts": 1,
  "numberOfInvoices": 1,
  "numberOfCreditMemos": 0,
  "startDate": "2022-04-25T19:08:34-07:00",
  "status": "Completed",
  "targetDate": "2022-07-30",
  "targetType": "SingleAccount",
  "totalTime": 3384,
  "accountId": "2c92c0f87270a5970172747e289a5e66",
  "noEmailForZeroAmountInvoice": false,
  "autoEmail": false,
  "autoPost": false,
  "autoRenewal": true,
  "invoicesEmailed": false,
  "includeSubscriptions": true,
  "includeOrderLineItems": true
}
```

**SDK Code**

```python Object Queries_queryBillingRunByKey_example
import requests

url = "https://rest.test.zuora.com/object-query/billing-runs/key"

querystring = {"fields[]":"[\"id,createddate\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Object Queries_queryBillingRunByKey_example
const url = 'https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Object Queries_queryBillingRunByKey_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Object Queries_queryBillingRunByKey_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Object Queries_queryBillingRunByKey_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Object Queries_queryBillingRunByKey_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Object Queries_queryBillingRunByKey_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Object Queries_queryBillingRunByKey_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-query/billing-runs/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```